Bug 1801013 - Review Request: date - Date and time library based on the C++11/14/17 <chrono> header
Summary: Review Request: date - Date and time library based on the C++11/14/17 <chrono...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Till Hofmann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-02-10 01:35 UTC by Aleksei Bavshin
Modified: 2020-02-20 05:03 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-11 04:53:03 UTC
Type: ---
thofmann: fedora-review+


Attachments (Terms of Use)

Description Aleksei Bavshin 2020-02-10 01:35:28 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/alebastr/waybar/fedora-rawhide-x86_64/01233939-date/date.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/alebastr/waybar/fedora-rawhide-x86_64/01233939-date/date-2.4.1-1.20200207git9a0ee25.fc32.src.rpm

Description:
Date and time library based on the C++11/14/17 <chrono> header. This is actually several separate libraries:
 - "date.h" is a header-only library which builds upon <chrono>.
   It adds some new duration types, and new time_point types. It also adds "field" types such as year_month_day which is a struct {year, month, day}. And it provides convenient means to convert between the "field" types and the time_point types.
 - "tz.h" / "tz.cpp" are a timezone library built on top of the "date.h" library. This timezone library is a complete parser of the IANA timezone database. It provides for an easy way to access all of the data in this database, using the types from "date.h" and <chrono>. The IANA database also includes data on leap seconds, and this library provides utilities to compute with that information as well.
   <...> (see spec or upstream github for a full description)
Slightly modified versions of "date.h" and "tz.h" were voted into the C++20 working draft.

Fedora Account System Username: alebastr

Q/A section:
- Why do I want to package this?
  New version of waybar will depend on timezone library. The alternative would be bundling the library with waybar which I want to avoid.
- Why is the name so generic?
  It's upstream project name. It's worth noting that the project installs headers under /usr/include/date and ships cmake and pkgconfig modules under the same name.  Any renaming should be carefully considered.
- Why am I packaging git snapshot?
  Last released version is 2 years old and contains only rudimentary CMake support. Extracting patch with only CMake changes is unfeasible due to the amount of such changes.
  Also, upstream author recommends to use master branch instead of latest release: https://github.com/HowardHinnant/date/issues/533.
- Why certain test sources are deleted in the spec?
  The upstream's test suite does not support excluding specific tests. It looks for files matching specific patterns, compiles and runs all of them.
  One of the tests I removed would always fail with gcc. The other one could fail in mock builder due to incorrect timezone configuration within the chroot.

Comment 1 Till Hofmann 2020-02-10 07:06:56 UTC
It's worth mentioning that this library is the basis for the C++20 extensions for chrono:
https://github.com/HowardHinnant/date#standardization
So I think the generic name is fine.

Maybe renaming to `libdate` would make it clear that it's a library? Do other distros already package the library? If so, with what name?

Comment 2 Aleksei Bavshin 2020-02-10 07:23:48 UTC
(In reply to Till Hofmann from comment #1)
> Maybe renaming to `libdate` would make it clear that it's a library? Do
> other distros already package the library? If so, with what name?

According to https://repology.org/project/howard-hinnant-date/versions it's either `date` or variations of `howard-hinnant-date`. NixOS package (still in review) is also going as `date`.
Renaming the whole package to `libdate` might be slightly confusing because right now it provides binary package `libtz` along with `date-devel` and virtual `date-static` for header-only parts.

Comment 3 Till Hofmann 2020-02-10 08:22:57 UTC
Alright, let's stick with `date` then.

I'll do a review.

Comment 4 Till Hofmann 2020-02-10 11:17:57 UTC
Looks good, approved!

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Expat License", "Expat
     License". 16 files have unknown license. Detailed output of
     licensecheck in /home/thofmann/fedora/reviews/review-
     date/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in libtz ,
     date-devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libtz-2.4.1-1.20200207git9a0ee25.fc32.x86_64.rpm
          date-devel-2.4.1-1.20200207git9a0ee25.fc32.x86_64.rpm
          date-debugsource-2.4.1-1.20200207git9a0ee25.fc32.x86_64.rpm
          date-2.4.1-1.20200207git9a0ee25.fc32.src.rpm
libtz.x86_64: W: spelling-error %description -l en_US chrono -> chronic
libtz.x86_64: W: no-documentation
date-devel.x86_64: W: no-dependency-on date/date-libs/libdate
date-devel.x86_64: W: spelling-error Summary(en_US) chrono -> chronic
date-devel.x86_64: W: spelling-error %description -l en_US chrono -> chronic
date-devel.x86_64: W: spelling-error %description -l en_US struct -> strict, strut, struck
date-devel.x86_64: W: spelling-error %description -l en_US tz -> t, z, ts
date-devel.x86_64: W: spelling-error %description -l en_US cpp -> cop, pp, cps
date-devel.x86_64: W: spelling-error %description -l en_US iso -> ISO, is, so
date-devel.x86_64: W: spelling-error %description -l en_US julian -> Julian, julienne
date-devel.x86_64: W: spelling-error %description -l en_US proleptic -> epileptic
date-devel.x86_64: W: spelling-error %description -l en_US interoperable -> inter operable, inter-operable, insuperable
date-devel.x86_64: W: spelling-error %description -l en_US islamic -> Islamic, mislaid
date.src: W: spelling-error Summary(en_US) chrono -> chronic
date.src: W: name-repeated-in-summary C Date
date.src: W: spelling-error %description -l en_US chrono -> chronic
4 packages and 0 specfiles checked; 0 errors, 16 warnings.




Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
date-devel.x86_64: W: no-dependency-on date/date-libs/libdate
date-devel.x86_64: W: spelling-error Summary(en_US) chrono -> chronic
date-devel.x86_64: W: spelling-error %description -l en_US chrono -> chronic
date-devel.x86_64: W: spelling-error %description -l en_US struct -> strict, strut, struck
date-devel.x86_64: W: spelling-error %description -l en_US tz -> t, z, ts
date-devel.x86_64: W: spelling-error %description -l en_US cpp -> cop, pp, cps
date-devel.x86_64: W: spelling-error %description -l en_US iso -> ISO, is, so
date-devel.x86_64: W: spelling-error %description -l en_US julian -> Julian, julienne
date-devel.x86_64: W: spelling-error %description -l en_US proleptic -> epileptic
date-devel.x86_64: W: spelling-error %description -l en_US interoperable -> inter operable, inter-operable, insuperable
date-devel.x86_64: W: spelling-error %description -l en_US islamic -> Islamic, mislaid
date-devel.x86_64: W: invalid-url URL: https://github.com/HowardHinnant/date <urlopen error [Errno -2] Name or service not known>
date-debugsource.x86_64: W: invalid-url URL: https://github.com/HowardHinnant/date <urlopen error [Errno -2] Name or service not known>
libtz.x86_64: W: spelling-error %description -l en_US chrono -> chronic
libtz.x86_64: W: invalid-url URL: https://github.com/HowardHinnant/date <urlopen error [Errno -2] Name or service not known>
libtz.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 16 warnings.



Source checksums
----------------
https://github.com/HowardHinnant/date/archive/9a0ee2542848ab8625984fc8cdbfb9b5414c0082/date-2.4.1-20200207git9a0ee25.tar.gz :
  CHECKSUM(SHA256) this package     : 7d46a11469c1764e1a32c1c45e9bc95ca05673e1cd0be3e4e0741f6714fe262e
  CHECKSUM(SHA256) upstream package : 7d46a11469c1764e1a32c1c45e9bc95ca05673e1cd0be3e4e0741f6714fe262e


Requires
--------
libtz (rpmlib, GLIBC filtered):
    ld-linux-x86-64.so.2()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)
    tzdata

date-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    cmake-filesystem(x86-64)
    libtz(x86-64)
    libtz.so.2.4.1()(64bit)

date-debugsource (rpmlib, GLIBC filtered):



Provides
--------
libtz:
    libtz
    libtz(x86-64)
    libtz.so.2.4.1()(64bit)

date-devel:
    cmake(date)
    date-devel
    date-devel(x86-64)
    date-static
    pkgconfig(date)

date-debugsource:
    date-debugsource
    date-debugsource(x86-64)



Generated by fedora-review 0.7.4 (54fa030) last change: 2019-12-07
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -u https://bugzilla.redhat.com/show_bug.cgi?id=1801013
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, C/C++, Generic
Disabled plugins: Perl, PHP, Java, Haskell, R, Python, fonts, SugarActivity, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Gwyn Ciesla 2020-02-11 02:49:40 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/date

Comment 6 Fedora Update System 2020-02-12 04:06:56 UTC
FEDORA-2020-7371874e98 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-7371874e98

Comment 7 Fedora Update System 2020-02-12 20:41:19 UTC
date-2.4.1-1.20200207git9a0ee25.fc31, waybar-0.9.1-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-7371874e98

Comment 8 Fedora Update System 2020-02-20 05:03:49 UTC
date-2.4.1-1.20200207git9a0ee25.fc31, waybar-0.9.1-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.